function T = MSTeuh(X)
%dato X vettore di punti calcola tramite un'euristica di tipo divide et
%impera una approssimazione di un MST del grafo euclideo dato da X 

[n,m]=size(X);
index=(1:n)';
b=mean(X,1);
[~, ind]=min(vecnorm(X-ones(n,1)*b, 2,2));
s=X(ind,:);
index(ind)=[];
X(ind,:)=[];

grafo = MSTdivideetimperah(X,index, [ind,s],1,zeros(m,1));

Tab=table(grafo(:,1:2), grafo(:,3));
Tab.Properties.VariableNames={'EndNodes','Weight'};
T=graph(Tab); 



end

