function ploteuclidgraph(G,X)
%disegna un grafo euclideo G, con nodi di coordinate date da X, nella retta, nel piano o nello spazio

[~,m]=size(X);
E= G.Edges.EndNodes;

if iscell(E)
E= cellfun(@str2double, G.Edges.EndNodes);
end

[n,~]=size(E);

if m==1
   
    for j=1:n
        plot([X(E(j,1)),X(E(j,2))], [0.5,0.5], 'r-o' );
        hold on
    end
    hold off
end

if m==2
   
    for j=1:n
        plot([X(E(j,1),1);X(E(j,2),1)], [X(E(j,1),2);X(E(j,2),2)],'r-o' );
        hold on
    end
    hold off
end
if m==3
    
    for j=1:n
        plot3([X(E(j,1),1);X(E(j,2),1)], [X(E(j,1),2);X(E(j,2),2)], [X(E(j,1),3);X(E(j,2),3)], 'r-o' );
        hold on
    end
    hold off
end

if m>3
    fprintf("Il grafo  in dimensione %i \n ", m)
end

