%test che calcola e traccia un grafico di:
%peso dello spanning tree, frequenza dei nodi di grado 1,2,3, 4,5 e maggiori di 5, e
% grado medio su r istanze
%per grafi euclidei in Rn generati in modo aleatorio 
%e con numero di nodi uguale a 80*1, 80*2, 80*3, ..., 80*100
%e confronta i risultati nel caso si usi MSTJ, l'euristica MSTeuh,
%MSTeuhbar e MSTeusort.

%numero massimo di nodi (x80)
n=100;

%numero di test per ogni numero di nodi
r=5;

%dimensione dello spazio in cui sono contenuti i nodi
m=3;

peso_gen=zeros(n,1);
deg1_gen=zeros(n,1);
deg2_gen=zeros(n,1);
deg3_gen=zeros(n,1);
deg4_gen=zeros(n,1);
deg5_gen=zeros(n,1);
deg6_gen=zeros(n,1);
totdeg_gen=zeros(n,1);


peso_geneusort=zeros(n,1);
deg1_geneumsort=zeros(n,1);
deg2_geneusort=zeros(n,1);
deg3_geneusort=zeros(n,1);
deg4_geneusort=zeros(n,1);
deg5_geneusort=zeros(n,1);
deg6_geneumsort=zeros(n,1);
totdeg_geneusort=zeros(n,1);

peso_geneuh=zeros(n,1);
deg1_geneuh=zeros(n,1);
deg2_geneuh=zeros(n,1);
deg3_geneuh=zeros(n,1);
deg4_geneuh=zeros(n,1);
deg5_geneuh=zeros(n,1);
deg6_geneuh=zeros(n,1);
totdeg_geneuh=zeros(n,1);

peso_geneuhbar=zeros(n,1);
deg1_geneuhbar=zeros(n,1);
deg2_geneuhbar=zeros(n,1);
deg3_geneuhbar=zeros(n,1);
deg4_geneuhbar=zeros(n,1);
deg5_geneuhbar=zeros(n,1);
deg6_geneuhbar=zeros(n,1);
totdeg_geneuhbar=zeros(n,1);


for k=n:-1:1
    
peso=zeros(r,1);
deg1=zeros(r,1);
deg2=zeros(r,1);
deg3=zeros(r,1);
deg4=zeros(r,1);
deg5=zeros(r,1);
deg6=zeros(r,1);
totdeg=zeros(r,1);

pesoeusort=zeros(r,1);
deg1eusort=zeros(r,1);
deg2eusort=zeros(r,1);
deg3eusort=zeros(r,1);
deg4eusort=zeros(r,1);
deg5eusort=zeros(r,1);
deg6eusort=zeros(r,1);
totdegeusort=zeros(r,1);

pesoeuh=zeros(r,1);
deg1euh=zeros(r,1);
deg2euh=zeros(r,1);
deg3euh=zeros(r,1);
deg4euh=zeros(r,1);
deg5euh=zeros(r,1);
deg6euh=zeros(r,1);
totdegeuh=zeros(r,1);

pesoeuhbar=zeros(r,1);
deg1euhbarg=zeros(r,1);
deg2euhbar=zeros(r,1);
deg3euhbar=zeros(r,1);
deg4euhbar=zeros(r,1);
deg5euhbar=zeros(r,1);
deg6euhbar=zeros(r,1);
totdegeuhbar=zeros(r,1);


for s=1:r
v=random('Uniform', 0, 1,[80*k,m]);
T=MSTJ(v);
T_deg=degree(T);
T_w=sum(T.Edges.Weight);

peso(s)=T_w;
deg1(s)=mean((T_deg==1));
deg2(s)=mean((T_deg==2));
deg3(s)=mean((T_deg==3));
deg4(s)=mean((T_deg==4));
deg5(s)=mean((T_deg==5));
deg6(s)=mean((T_deg>=6));
totdeg(s)=mean(T_deg);


T=MSTeuh(v);
T_deg=degree(T);
T_w=sum(T.Edges.Weight);

pesoeuh(s)=T_w;
deg1euh(s)=mean((T_deg==1));
deg2euh(s)=mean((T_deg==2));
deg3euh(s)=mean((T_deg==3));
deg4euh(s)=mean((T_deg==4));
deg5euh(s)=mean((T_deg==5));
deg6euh(s)=mean((T_deg>=6));
totdegeuh(s)=mean(T_deg);

T=MSTeuhbar(v);
T_deg=degree(T);
T_w=sum(T.Edges.Weight);

pesoeuhbar(s)=T_w;
deg1euhbarg(s)=mean((T_deg==1));
deg2euhbar(s)=mean((T_deg==2));
deg3euhbar(s)=mean((T_deg==3));
deg4euhbar(s)=mean((T_deg==4));
deg5euhbar(s)=mean((T_deg==5));
deg6euhbar(s)=mean((T_deg>=6));
totdegeuhbar(s)=mean(T_deg);

T=MSTeusort(v);
T_deg=degree(T);
T_w=sum(T.Edges.Weight);

pesoeusort(s)=T_w;
deg1eusort(s)=mean((T_deg==1));
deg2eusort(s)=mean((T_deg==2));
deg3eusort(s)=mean((T_deg==3));
deg4eusort(s)=mean((T_deg==4));
deg5eusort(s)=mean((T_deg==5));
deg6eusort(s)=mean((T_deg>=6));
totdegeusort(s)=mean(T_deg);

end
peso_gen(k)=mean(peso);
deg1_gen(k)=mean(deg1);
deg2_gen(k)=mean(deg2);
deg3_gen(k)=mean(deg3);
deg4_gen(k)=mean(deg4);
deg5_gen(k)=mean(deg5);
deg6_gen(k)=mean(deg6);
totdeg_gen(k)=mean(totdeg);

peso_geneusort(k)=mean(pesoeusort);
deg1_geneumsort(k)=mean(deg1eusort);
deg2_geneusort(k)=mean(deg2eusort);
deg3_geneusort(k)=mean(deg3eusort);
deg4_geneusort(k)=mean(deg4eusort);
deg5_geneusort(k)=mean(deg5eusort);
deg6_geneumsort(k)=mean(deg6eusort);
totdeg_geneusort(k)=mean(totdegeusort);

peso_geneuh(k)=mean(pesoeuh);
deg1_geneuh(k)=mean(deg1euh);
deg2_geneuh(k)=mean(deg2euh);
deg3_geneuh(k)=mean(deg3euh);
deg4_geneuh(k)=mean(deg4euh);
deg5_geneuh(k)=mean(deg5euh);
deg6_geneuh(k)=mean(deg6euh);
totdeg_geneuh(k)=mean(totdegeuh);

peso_geneuhbar(k)=mean(pesoeuhbar);
deg1_geneuhbar(k)=mean(deg1euhbarg);
deg2_geneuhbar(k)=mean(deg2euhbar);
deg3_geneuhbar(k)=mean(deg3euhbar);
deg4_geneuhbar(k)=mean(deg4euhbar);
deg5_geneuhbar(k)=mean(deg5euhbar);
deg6_geneuhbar(k)=mean(deg6euhbar);
totdeg_geneuhbar(k)=mean(totdegeuhbar);

end

t=1:n;
t=80*t;

figure (1)
plot(t,peso_gen)
hold on
plot(t,peso_geneuh)
plot(t,peso_geneuhbar)
plot(t,peso_geneusort)

legend('MST','euh', 'eubar','eusort', 'Location', 'best')
xlabel('numero nodi ')
ylabel('peso del MST')
hold off

figure (2)
plot(t,deg1_gen)
hold on
plot(t,deg1_geneuh)
plot(t,deg1_geneuhbar)
plot(t,deg1_geneumsort)
ylim([0,1])
legend('MST','euh', 'eubar','eusort', 'Location', 'best')
xlabel('numero nodi (x5)')
ylabel('frequenza dei nodi di grado 1')
hold off

figure (3)
plot(t,deg2_gen)
hold on
plot(t,deg2_geneuh)
plot(t,deg2_geneuhbar)
plot(t,deg2_geneusort)
ylim([0,1])
legend('MST','euh', 'eubar','eusort','Location', 'best')
xlabel('numero nodi')
ylabel('frequenza dei nodi di grado 2')
hold off

figure (4)
plot(t,deg3_gen)
hold on
plot(t,deg3_geneuh)
plot(t,deg3_geneuhbar)
plot(t,deg3_geneusort)
ylim([0,1])
legend('MST','euh', 'eubar','eusort','Location', 'best')
xlabel('numero nodi ')
ylabel('frequenza dei nodi di grado 3' )
hold off

figure (5)
plot(t,deg4_gen)
hold on
plot(t,deg4_geneuh)
plot(t,deg4_geneuhbar)
plot(t,deg4_geneusort)
ylim([0,1])
legend('Prim','euh', 'eubar','eusort','Location', 'best')
xlabel('numero nodi')
ylabel('frequenza dei nodi di grado 4' )
hold off

figure (6)
plot(t,deg5_gen)
hold on
plot(t,deg5_geneuh)
plot(t,deg5_geneuhbar)
plot(t,deg5_geneusort)
legend('Prim','euh', 'eubar','eusort', 'Location', 'best')
xlabel('numero nodi')
ylabel('frequenza dei nodi di grado 5' )
hold off

figure (7)
plot(t,deg6_gen)
hold on
plot(t,deg6_geneuh)
plot(t,deg6_geneuhbar)
plot(t,deg6_geneumsort)
legend('Prim','euh', 'eubar','eusort',  'Location', 'best')
xlabel('numero nodi')
ylabel('frequenza dei nodi di grado maggiore di 5' )
hold off

figure (8)
plot(t,totdeg_gen)
hold on
plot(t,totdeg_geneuh)
plot(t,totdeg_geneuhbar)
plot(t,totdeg_geneusort)
legend('Prim','euh', 'eubar','eusort', 'Location', 'best')
xlabel('numero nodi')
ylabel('grado medio' )
hold off
