function [PQ,pos] = arrange(PQ,n,pos, j)
%riordina l'heap deglia archi a partire da un heap non ordinato 
%nel solo nodo nella j-esima posizione all'interno dell'heap

%nodo padre nell'heap
fath=floor(j/2);

%caso nodo j ha priorit pi alta del padre
while(j>1 && PQ(j,2)<PQ(fath,2)) %verifica che non sia gi ordinato
    
    %scambia i nodi e aggiorna le posizioni
    PQ([j,fath],:)=PQ([fath,j],:);
    pos([PQ(j,1),PQ(fath,1)])= pos([PQ(fath,1),PQ(j,1)]);
   j=fath;
   fath=floor(j/2);
  
end

%caso nodo j ha priorit pi bassa di un suo figlio
while((2*j)<=n && j~=bestfch(PQ,n,j)) %verifica che vi sia un figlio sinistro e che l'heap non sia gi ordinato
    
   %posizione nell'heap del figlio con priorit pi alta
   k=bestfch(PQ,n,j);
   %scambia j con il figlio e aggiorna le posizioni
   PQ([k,j],:)=PQ([j,k],:);
   pos([PQ(k,1),PQ(j,1)])=pos([PQ(j,1),PQ(k,1)]);
   j=k;
  
end
end

