function T = euclmatlabMST(X)
%dati dei punti in Rn calcola la matrice di adiacenza del grafo euclideo
%corrispondente e calcola il minimum spanning tree
[n,~]=size(X);
A=zeros(n,n);

    for k=1:n-1
        
        A(k+1:n,k)=vecnorm((X(k+1:n,:)-ones(n-k,1)*X(k,:)),2,2);
       
    end


G = graph(A,'lower');
T=minspantree(G);
end

